<?php

function ecpay_epclient_page(){
  $order_id=arg(1);
  $order=commerce_order_load($order_id);
  if(!empty($order) and !empty($_POST)){

    //判斷帶回來的參數
    $AL = new ECPay_AllInOne();
    $AL->MerchantID = variable_get('ecpay_MerchantID');
    $AL->HashKey = variable_get('ecpay_HashKey');
    $AL->HashIV = variable_get('ecpay_HashIV');
    // $AL->encryptType = ECPay_EncryptType::ENC_MD5; // MD5
    $AL->EncryptType = ECPay_EncryptType::ENC_SHA256; // SHA256
    $ecpay_feedback=$AL->CheckOutFeedback();
    $SpRtCode=array(1,2,10100073);
    if(!in_array($ecpay_feedback['RtnCode'],$SpRtCode)){
      drupal_set_message(t('付款發生錯誤。錯誤代碼：@RtnCode。回傳錯誤訊息：@RtnMsg。請重新付款或聯絡系統管理員',array('@RtnCode'=>$ecpay_feedback['RtnCode'],'@RtnMsg'=>$ecpay_feedback['RtnMsg'])),'error');
    }

    drupal_goto(commerce_checkout_order_uri($order));
  }
  else{
    drupal_exit();
  }
}


/*
*  金流結果回傳
*/
function ecpay_returnrul_page(){

  $result_msg = ecpay_update_order_message();
  echo $result_msg;
}

/**
*   付款結果通知
**/
function ecpay_update_order_message()
{

    try {

        $AL = new ECPay_AllInOne();
        $AL->MerchantID = variable_get('ecpay_MerchantID');
        $AL->HashKey = variable_get('ecpay_HashKey');
        $AL->HashIV = variable_get('ecpay_HashIV');
        // $AL->encryptType = ECPay_EncryptType::ENC_MD5; // MD5
        $AL->EncryptType = ECPay_EncryptType::ENC_SHA256; // SHA256
        $ecpay_feedback=$AL->CheckOutFeedback();
        //ddl($ecpay_feedback);
        unset($AL);

        //綠界回傳資訊
        $MerchantTradeNo = $ecpay_feedback['MerchantTradeNo'];
        $RtnMsg = $ecpay_feedback['RtnMsg'];
        $RtnCode = $ecpay_feedback['RtnCode'];
        $TradeAmt = $ecpay_feedback['TradeAmt'];
        $PaymentType = $ecpay_feedback['PaymentType'];
        $ShortPayment = explode('_',$PaymentType)[0];
        //不同付款方式有額外資訊
        switch ($ShortPayment) {
          case 'ATM':
            $BankCode = $ecpay_feedback['BankCode'];
            $vAccount = $ecpay_feedback['vAccount'];
            $ExpireDate = $ecpay_feedback['ExpireDate'];
            break;

          case 'CVS':
            $PaymentNo = $ecpay_feedback['PaymentNo'];
            $ExpireDate = $ecpay_feedback['ExpireDate'];
            break;

          case 'BARCODE':
            $Barcode1 = $ecpay_feedback['Barcode1'];
            $Barcode2 = $ecpay_feedback['Barcode2'];
            $Barcode3 = $ecpay_feedback['Barcode3'];
            $ExpireDate = $ecpay_feedback['ExpireDate'];

          default:
            # code...
            break;
        }




        // 訂單資訊
        $order_id = substr($MerchantTradeNo, 14);
        $order = commerce_order_load($order_id);
        $amount = $order->commerce_order_total['und'][0]['amount'];
        $TotalAmount = commerce_currency_amount_to_decimal($amount, 'TWD');


        // 確認金額正確，雖然應該錯誤機會不大，但是還是寫一下
        if (round($TotalAmount) != $TradeAmt) {
            throw new Exception(sprintf(ECPAY_AMOUNT_ERROR, $order_id));
        }


        //更新交易紀錄（Payment Transaction）,這裡不管交易成功還是失敗，都要紀錄下來
        $condition = array(
          'order_id' => $order_id,
          'remote_id' => $MerchantTradeNo,
        );
        $payment_array = commerce_payment_transaction_load_multiple(array(), $condition, false);
        foreach ($payment_array as $key => $value) {
          $transaction = $value; //此筆交易物件
        }

        $status = $transaction->status;

        //開始判斷這次的交易是否成功，如果成功就更新交易紀錄與訂單狀態
        //當然失敗就要把原因紀錄下來，並且更新訂單狀態到重新選擇付款方式

        //交易成功，更新交易紀錄，並且要確定這筆訂單沒有被更新過..
        if ($RtnCode == 1 && $status=='pending') {

          $transaction->message .= sprintf('交易結果 : (%s)%s </br>',$RtnCode,$RtnMsg);
          $transaction->status = COMMERCE_PAYMENT_STATUS_SUCCESS;
          commerce_payment_transaction_save($transaction);

          //更新訂單狀態
          $order->status='pending';
          commerce_order_save($order);
          commerce_checkout_complete($order);
        }
        //這個是ATM櫃員機專用..
        elseif($RtnCode == 2 && $status=='pending' && $ShortPayment=='ATM'){
           $transaction->message .=sprintf('銀行代碼:%s </br>繳費虛擬帳號：%s </br>繳費期限：%s </br>',$BankCode,$vAccount,$ExpireDate);
           commerce_payment_transaction_save($transaction);

           //更新訂單狀態
           commerce_order_status_update($order, 'processing',FALSE, $revision = NULL, $log = 'ATM櫃員機申請成功，等待付款');
        }
        //這個是CVS重用
        elseif($RtnCode == 10100073 && $status=='pending' && $ShortPayment=='CVS'){
          $transaction->message .=sprintf('超商代碼:%s </br>繳費期限：%s </br>',$PaymentNo,$ExpireDate);
          commerce_payment_transaction_save($transaction);
          //更新訂單狀態
          commerce_order_status_update($order, 'processing',FALSE, $revision = NULL, $log = '超商代碼申請成功，等待付款');
        }
        //這個給Barcode
        elseif($RtnCode == 10100073 && $status=='pending' && $ShortPayment=='BARCODE'){
          $transaction->message .=sprintf('Barcode1:%s </br>Barcode2:%s </br>Barcode3:%s </br>繳費期限：%s </br>',$Barcode1,$Barcode2,$Barcode3,$ExpireDate);
          commerce_payment_transaction_save($transaction);
          //更新訂單狀態
          commerce_order_status_update($order, 'processing',FALSE, $revision = NULL, $log = '超商代碼申請成功，等待付款');
        }
        else { //交易有問題，更改交易紀錄為失敗。並且將訂單狀態修改為重新付款
            $transaction->message .= sprintf(ECPAY_RETURN_ERROR, $order_id, $RtnCode, $RtnMsg).'</br>';
            $transaction->status = COMMERCE_PAYMENT_STATUS_FAILURE;
            commerce_payment_transaction_save($transaction);

            //訂單狀態可以重新更新，然後讓這筆訂單可以重新選擇付款方式
            commerce_payment_redirect_pane_previous_page($order,sprintf(ECPAY_RETURN_ERROR, $order_id, $RtnCode, $RtnMsg));
            throw new Exception(sprintf(ECPAY_RETURN_ERROR, $order_id, $RtnCode, $RtnMsg));
        }

        $result_msg = '1|OK';

    } catch (Exception $e) {
        $error = $e->getMessage();
        // 設定錯誤訊息
        $result_msg = '0|'.$error;
    }

    return $result_msg;
}
?>
