<?php

/**
 * Payment method callback: settings form.
 */
function ecpay_atm_payment_settings_form($settings = array()) {

  for($i=1;$i <= 60;$i++){
      $expiredate_option[$i]=$i;
  }
  $form = array();


  $form['ExpireDate'] = array(
    '#type' => 'select',
    '#title' => t('允許繳費有效天數'),
    '#description' => t('若需設定最長 60 天，最短 1 天。未設定此參數則預設為 3 天。注意事項：以天為單位'),
    '#options' => $expiredate_option,
    '#default_value' => empty($settings['ExpireDate'])?'3':$settings['ExpireDate'],
  );
  return $form;
}

/**
 * Payment method callback: CALLBACK_commerce_payment_method_submit_form
 */
function ecpay_atm_payment_submit_form($payment_method, $pane_values, $checkout_pane, $order) {
  $form = array();
  return $form;
}

/**
 * Payment method callback: CALLBACK_commerce_payment_method_redirect_form
 */
function ecpay_atm_payment_redirect_form($form, &$form_state, $order, $payment_method) {
  return ecpay_atm_payment_form($form, $form_state, $order,$payment_method);
}


function ecpay_atm_payment_form($form, $form_state, $order,$payment_method){

  try {

    //預設環境，若沒有設定則用測試環境。
    $status=variable_get('ecpay_status','dev');

    if ($status == 'dev') {
      $service_url = ECPAY_TEST_SERVICE_URL;
		} else {
			$service_url = ECPAY_SERVICE_URL;
		}

    $obj = new ECPay_AllInOne();

    //服務參數
    $obj->ServiceURL  =  $service_url;   //服務位置
    $obj->HashKey     =  variable_get('ecpay_HashKey', '') ;                                           //測試用Hashkey，請自行帶入ECPay提供的HashKey
    $obj->HashIV      =  variable_get('ecpay_HashIV', '') ;                                           //測試用HashIV，請自行帶入ECPay提供的HashIV
    $obj->MerchantID  =  variable_get('ecpay_MerchantID', '');                                                     //測試用MerchantID，請自行帶入ECPay提供的MerchantID
    $obj->EncryptType =  '1';

    //基本參數(請依系統規劃自行調整)
    $MerchantTradeNo = date('YmdHis').$order->order_id ; //扣除前面14碼，最後變成是訂單號碼
    $obj->Send['ReturnURL'] = url('checkout/'. $order->order_id.'/epreturnurl', array('absolute' => true));
		$obj->Send['ClientBackURL'] = url('checkout/'. $order->order_id, array('absolute' => true));
    $obj->Send['OrderResultURL']=url('checkout/'. $order->order_id, array('absolute' => true));
    $obj->Send['MerchantTradeNo']   = $MerchantTradeNo;                          //訂單編號
    $obj->Send['MerchantTradeDate'] = date('Y/m/d H:i:s');                       //交易時間
    // Set the product info
    $amount=$order->commerce_order_total['und'][0]['amount'];
    $TotalAmount=commerce_currency_amount_to_decimal($amount,'TWD');
    $obj->Send['TotalAmount']       = round($TotalAmount);                       //交易金額[確保送到綠界的金額是正的（有時候因為discount會造成問題）]
    $obj->Send['TradeDesc']         = variable_get("ecpay_TradeDesc",'Buy Something using Commerce Ecpay AllInOne Module created by HelloSanta Corp.') ;                          //交易描述
    $obj->Send['ChoosePayment']     = ECPay_PaymentMethod::ATM;              //付款方式:Credit

    //訂單的商品資料
    array_push(
			$obj->Send['Items'],
			array(
				'Name' => t('購買一些品項'),
				'Price' => round($TotalAmount),
				'Currency' => 'TWD',
				'Quantity' => 1,
        'URL'=>url(NULL,array('absolute'=>true)),
			)
		);

    //ATM 延伸參數(可依系統需求選擇是否代入)
    $obj->SendExtend['ExpireDate'] =  empty($payment_method['settings']['ExpireDate'])?'3':$payment_method['settings']['ExpireDate'];     //繳費期限 (預設3天，最長60天，最短1天)
    $obj->SendExtend['PaymentInfoURL'] = url('checkout/'. $order->order_id.'/epreturnurl', array('absolute' => true)); //伺服器端回傳付款相關資訊。

    # 電子發票參數
    /*
    $obj->Send['InvoiceMark'] = ECPay_InvoiceState::Yes;
    $obj->SendExtend['RelateNumber'] = "Test".time();
    $obj->SendExtend['CustomerEmail'] = 'test@ecpay.com.tw';
    $obj->SendExtend['CustomerPhone'] = '0911222333';
    $obj->SendExtend['TaxType'] = ECPay_TaxType::Dutiable;
    $obj->SendExtend['CustomerAddr'] = '台北市南港區三重路19-2號5樓D棟';
    $obj->SendExtend['InvoiceItems'] = array();
    // 將商品加入電子發票商品列表陣列
    foreach ($obj->Send['Items'] as $info)
    {
        array_push($obj->SendExtend['InvoiceItems'],array('Name' => $info['Name'],'Count' =>
            $info['Quantity'],'Word' => '個','Price' => $info['Price'],'TaxType' => ECPay_TaxType::Dutiable));
    }
    $obj->SendExtend['InvoiceRemark'] = '測試發票備註';
    $obj->SendExtend['DelayDay'] = '0';
    $obj->SendExtend['InvType'] = ECPay_InvType::General;
    */


		// Get the chosen payment ,installment and payment description
		$choose_payment_desc = '';
		$choose_payment = ECPay_PaymentMethod::ATM;
		$choose_installment = '';
		$payment_type = array();
		if (isset($_SESSION['ecpay_choose_payment'])) {
			$choose_payment_desc = get_ecpay_payment_desc($_SESSION['ecpay_choose_payment']);
			if (!empty($choose_payment_desc)) {
				$payment_type = explode('_', $_SESSION['ecpay_choose_payment']);
				$choose_payment = $payment_type[0];
				if (isset($payment_type[1])) {
					$choose_installment = $payment_type[1];
				}
			}
			unset($_SESSION['ecpay_choose_payment']);
		}

    //建立payment記錄
    $transaction = commerce_payment_transaction_new($payment_method['method_id'], $order->order_id);
    $transaction->instance_id = $payment_method['instance_id'];
    $transaction->amount = $order->commerce_order_total['und'][0]['amount'];
    $transaction->currency_code = $order->commerce_order_total['und'][0]['currency_code'];
    $transaction->remote_id = $obj->Send['MerchantTradeNo'];
    $transaction->status = COMMERCE_PAYMENT_STATUS_PENDING;
    commerce_payment_transaction_save($transaction);

    /* 產生訂單 */
    $obj->CheckOut();

		//echo $redirect_html;
		exit;

  } catch (Exception $e) {
    drupal_set_message($e->getMessage(), 'error');
		drupal_goto('cart/checkout');
    return false;
  }

}

?>
