<?php

/**
 * Payment method callback: settings form.
 */
function ecpay_credit_card_payment_settings_form($settings = array()) {

  $form['BindingCard']=array(
    '#type' => 'radios',
    '#title'=>t('記憶信用卡'),
    '#description'=>t('若要記憶信用卡，則客人帶到綠界的時候，將會自動顯示前次的信用卡卡號'),
    '#options' => array(
        'false' => t('不啟用'),
        'true' => t('啟用'),
    ),
    '#default_value' => !empty(variable_get("BindingCard"))?variable_get("BindingCard"):'false',
  );

  return $form;

}



/**
 * Payment method callback: CALLBACK_commerce_payment_method_submit_form
 */
function ecpay_credit_card_payment_submit_form($payment_method, $pane_values, $checkout_pane, $order) {
  $form = array();

  return $form;
}

/**
 * Payment method callback: CALLBACK_commerce_payment_method_redirect_form
 */
function ecpay_credit_card_payment_redirect_form($form, &$form_state, $order, $payment_method) {
  return ecpay_credit_card_payment_form($form, $form_state, $order,$payment_method);
}


function ecpay_credit_card_payment_form($form, $form_state, $order,$payment_method){

  try {

    global $user;

    //預設環境，若沒有設定則用測試環境。
    $status=variable_get('ecpay_status','dev');

    if ($status == 'dev') {
      $service_url = ECPAY_TEST_SERVICE_URL;
		} else {
			$service_url = ECPAY_SERVICE_URL;
		}

    $obj = new ECPay_AllInOne();

    //服務參數
    $obj->ServiceURL  =  $service_url;   //服務位置
    $obj->HashKey     =  variable_get('ecpay_HashKey', '') ;                                           //測試用Hashkey，請自行帶入ECPay提供的HashKey
    $obj->HashIV      =  variable_get('ecpay_HashIV', '') ;                                           //測試用HashIV，請自行帶入ECPay提供的HashIV
    $obj->MerchantID  =  variable_get('ecpay_MerchantID', '');                                                     //測試用MerchantID，請自行帶入ECPay提供的MerchantID
    $obj->EncryptType =  '1';
    

    //基本參數(請依系統規劃自行調整)
    $MerchantTradeNo = date('YmdHis').$order->order_id ; //扣除前面14碼，最後變成是訂單號碼
    $obj->Send['ReturnURL'] = url('checkout/'. $order->order_id.'/epreturnurl', array('absolute' => true));
		$obj->Send['ClientBackURL'] = url('checkout/'. $order->order_id.'/epclient', array('absolute' => true));
    $obj->Send['OrderResultURL']=url('checkout/'. $order->order_id.'/epclient', array('absolute' => true));
    $obj->Send['MerchantTradeNo']   = $MerchantTradeNo;                          //訂單編號
    $obj->Send['MerchantTradeDate'] = date('Y/m/d H:i:s');                       //交易時間
    // Set the product info
    $amount=$order->commerce_order_total['und'][0]['amount'];
    $TotalAmount=commerce_currency_amount_to_decimal($amount,'TWD');
    $obj->Send['TotalAmount']       = round($TotalAmount);                       //交易金額[確保送到綠界的金額是正的（有時候因為discount會造成問題）]
    $obj->Send['TradeDesc']         = variable_get("ecpay_TradeDesc",'Buy Something using Commerce Ecpay AllInOne Module created by HelloSanta Corp.') ;                          //交易描述
    $obj->Send['ChoosePayment']     = ECPay_PaymentMethod::Credit ;              //付款方式:Credit

    //訂單的商品資料
    array_push(
			$obj->Send['Items'],
			array(
				'Name' => t('購買一些品項'),
				'Price' => round($TotalAmount),
				'Currency' => 'TWD',
				'Quantity' => 1,
        'URL'=>url(NULL,array('absolute'=>true)),
			)
		);

    //Credit信用卡分期付款延伸參數(可依系統需求選擇是否代入)
    //以下參數不可以跟信用卡定期定額參數一起設定
    $obj->SendExtend['CreditInstallment'] = '' ;    //分期期數，預設0(不分期)，信用卡分期可用參數為:3,6,12,18,24
    $obj->SendExtend['InstallmentAmount'] = 0 ;    //使用刷卡分期的付款金額，預設0(不分期)
    $obj->SendExtend['Redeem'] = false ;           //是否使用紅利折抵，預設false
    $obj->SendExtend['UnionPay'] = false;          //是否為聯營卡，預設false;

    //記憶信用卡卡號
    $BindingCard=empty($payment_method['settings']['BindingCard'])?'false':$payment_method['settings']['BindingCard'];
    if($BindingCard){
      $obj->SendExtend['BindingCard'] = 1;
      $obj->SendExtend['MerchantMemberID']=variable_get('ecpay_MerchantID', '').'hsecpay'.$user->uid; 
    }


    //Credit信用卡定期定額付款延伸參數(可依系統需求選擇是否代入)
    //以下參數不可以跟信用卡分期付款參數一起設定
    // $obj->SendExtend['PeriodAmount'] = '' ;    //每次授權金額，預設空字串
    // $obj->SendExtend['PeriodType']   = '' ;    //週期種類，預設空字串
    // $obj->SendExtend['Frequency']    = '' ;    //執行頻率，預設空字串
    // $obj->SendExtend['ExecTimes']    = '' ;    //執行次數，預設空字串

    # 電子發票參數
    /*
    $obj->Send['InvoiceMark'] = ECPay_InvoiceState::Yes;
    $obj->SendExtend['RelateNumber'] = "Test".time();
    $obj->SendExtend['CustomerEmail'] = 'test@ecpay.com.tw';
    $obj->SendExtend['CustomerPhone'] = '0911222333';
    $obj->SendExtend['TaxType'] = ECPay_TaxType::Dutiable;
    $obj->SendExtend['CustomerAddr'] = '台北市南港區三重路19-2號5樓D棟';
    $obj->SendExtend['InvoiceItems'] = array();
    // 將商品加入電子發票商品列表陣列
    foreach ($obj->Send['Items'] as $info)
    {
        array_push($obj->SendExtend['InvoiceItems'],array('Name' => $info['Name'],'Count' =>
            $info['Quantity'],'Word' => '個','Price' => $info['Price'],'TaxType' => ECPay_TaxType::Dutiable));
    }
    $obj->SendExtend['InvoiceRemark'] = '測試發票備註';
    $obj->SendExtend['DelayDay'] = '0';
    $obj->SendExtend['InvType'] = ECPay_InvType::General;
    */


		// Get the chosen payment ,installment and payment description
		$choose_payment_desc = '';
		$choose_payment = ECPay_PaymentMethod::Credit;
		$choose_installment = '';
		$payment_type = array();
		if (isset($_SESSION['ecpay_choose_payment'])) {
			$choose_payment_desc = get_ecpay_payment_desc($_SESSION['ecpay_choose_payment']);
			if (!empty($choose_payment_desc)) {
				$payment_type = explode('_', $_SESSION['ecpay_choose_payment']);
				$choose_payment = $payment_type[0];
				if (isset($payment_type[1])) {
					$choose_installment = $payment_type[1];
				}
			}
			unset($_SESSION['ecpay_choose_payment']);
		}

    //建立payment記錄
    $transaction = commerce_payment_transaction_new($payment_method['method_id'], $order->order_id);
    $transaction->instance_id = $payment_method['instance_id'];
    $transaction->amount = $order->commerce_order_total['und'][0]['amount'];
    $transaction->currency_code = $order->commerce_order_total['und'][0]['currency_code'];
    $transaction->remote_id = $obj->Send['MerchantTradeNo'];
    $transaction->status = COMMERCE_PAYMENT_STATUS_PENDING;
    commerce_payment_transaction_save($transaction);

    /* 產生訂單 */
    $obj->CheckOut();

		//echo $redirect_html;
		exit;

  } catch (Exception $e) {
    drupal_set_message($e->getMessage(), 'error');
		drupal_goto('cart/checkout');
    return false;
  }

}

?>
